﻿// Copyright 2012 Max Toro Q.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Web.Http;
using System.Web.Http.Controllers;
using System.Web.Http.Dispatcher;
using System.Web.Http.Routing;

namespace MvcCodeRouting.Web.Http {
   
   class CustomHttpControllerSelector : DefaultHttpControllerSelector {

      public CustomHttpControllerSelector(HttpConfiguration configuration) 
         : base(configuration) { }

      public override HttpControllerDescriptor SelectController(HttpRequestMessage request) {

         IHttpRouteData routeData = request.GetRouteData();

         string controller;
         CodeHttpRoute codeRoute;

         if ((controller = routeData.Values["controller"] as string) == null 
            || (codeRoute = routeData.Route as CodeHttpRoute) == null) {
            return base.SelectController(request);
         }

         return codeRoute.ControllerDescriptors[controller];
      }
   }
}
