﻿// Copyright 2012 Max Toro Q.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Web.Hosting;

namespace MvcCodeRouting.Web.Hosting {

   class AssemblyResourceVirtualFile : VirtualFile {

      readonly string resourceName;
      readonly Assembly assembly;

      public AssemblyResourceVirtualFile(string virtualPath, string resourceName, Assembly assembly)
         : base(virtualPath) {

         this.resourceName = resourceName;
         this.assembly = assembly;
      }

      public override Stream Open() {
         return this.assembly.GetManifestResourceStream(resourceName);
      }
   }
}
